//
//  Person.m
//  Person
//
//  Created by park on 11. 9. 14..
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "Person.h"


@implementation Person
-(id) init {
    return [self initWithFirstName:@"Kyoung" lastName:@"Park"];
}

-(id) initWithFirstName:(NSString *) fname lastName:(NSString *)lname {
    return [self initWithFirstName:fname lastName: lname age:0];
}

-(id) initWithFirstName:(NSString *) fname lastName:(NSString *) lname age:(int) value {
    // allow super class to initialize its state first
    if ([super init]) {
        age = value;
        firstName = fname;
        lastName = lname;
    }
    return self;
}

-(void) dealloc {
    // do any cleanup that's necessary
    [firstName release];
    [lastName release];
    //when we're done, call super class to clean us up
    [super dealloc];
}

-(NSString *) description {
    return [NSString stringWithFormat:@"Person name is %@ %@ and age is %d", firstName, lastName, age];
}

@synthesize firstName;
@synthesize lastName;
@synthesize age;

/*
-(NSString *) firstName {
    return firstName;
}

-(void) setFirstName: (NSString *) value {
    if (firstName != value) {
        [firstName release];
        firstName = [value copy];
    }
}

-(NSString *) lastName {
    return lastName;
}

-(void) setLastName: (NSString *) value {
    if (lastName != value) {
        [lastName release];
        lastName = [value copy];
    }
}
*/

-(NSString *) fullName {
    NSString *result = [NSString stringWithFormat:@"%@ %@", firstName, lastName];
    return result;
}
//@synthesize fullName;
/*
-(int) age {
    return age;
}

-(void) setAge:(int)value {
    age = value;
}
*/

-(BOOL) canLegallyVote {
    return ([self age] >= 18);
}

-(void) castBallot {
    if ([self canLegallyVote]) {
        // do voting
        NSLog (@"Do voting");
    } else {
        NSLog (@"I'm not allowed to vote!");
    }
}

- (NSUInteger) hash; {
    return age ^ [firstName hash] ^ [lastName hash];
}

-(BOOL) isEqualToPerson: (Person *) other {
    if(self == other)    
        return YES;
    
    if (!([self firstName] ==[other firstName])) 
        return NO;
    if (!([self lastName] ==[other lastName])) 
        return NO;    
    if (!([self age] ==[other age]))   
        return NO;
    
    return YES;
}

-(BOOL) isEqual: (id) other {    
    if(other == self)
        return YES;
    if(!other || ![other isKindOfClass:[self class]])
        return NO;
    return [self isEqualToPerson:other];  
}

@end
