//
//  PersonAppDelegate.m
//  Person
//
//  Created by park on 11. 9. 14..
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "PersonAppDelegate.h"
#import "Person.h"

@implementation PersonAppDelegate

@synthesize window;

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
    // Insert code here to initialize your application
    Person * person = nil;
    person = [[Person alloc] init];
    //NSLog([person description]);   // you'll get the warning "Format string is not a string literal (potentially insecure)"
    NSLog(@"%@", person);   // -description method is called by NSLog
    [person castBallot];
    
    person.firstName = @"Kevin";
    person.lastName = @"Cho";
    person.age = 19;
    NSLog(@"%@", person);   // -description method is called by NSLog
    NSLog(@"FullName is %@", person.fullName);
    NSLog(@"Age is %d", person.age);
    [person castBallot];

    Person * person2 = nil;
    person2 = [[Person alloc] initWithFirstName:@"Kevin" lastName:@"Cho" age:19];
    NSLog(@"%@", person2);   // -description method is called by NSLog
    [person2 castBallot];

    // == operator
    if (person == person2) {
        NSLog(@"person & person2 points to the same object");
    } else {
        NSLog(@"person & person2 is not the same object");
    }
    Person * person3 = person;
    if (person == person3) {
        NSLog(@"person & person3 points to the same object");
    } else {
        NSLog(@"person & person3 is not the same object");
    }
    
    // isEqual
    if ([person2 isEqual: person3]) {
        NSLog(@"person2 & person3 is logically the same");
    } else {
        NSLog(@"person2 & person3 is not logically the same");
    }
    if ([person isEqual: person2]) {
        NSLog(@"person & person2 is logically the same");
    } else {
        NSLog(@"person & person2 is not logically the same");
    }
    
    // Object equality and identity
    NSString * a = [NSString stringWithFormat:@"This is a string"];
    NSString * b = [NSString stringWithFormat:@"This is a string"];
    NSString * c = [NSString stringWithFormat:@"This is a longer string"];
    if (a==b) {
        NSLog(@"a is identical to b");
    }
    if (a==c) {
        NSLog(@"a is identical to c");
    }
    if ([a isEqual:b]) {
        NSLog(@"a is equal to b"); // only this is true
    }
    if ([a isEqual:c]) {
        NSLog(@"a is equal to c");
    }
    a = @"This is a string";
    b = @"This is a string";
    c = @"This is a longer string";
    if (a==b) {
        NSLog(@"a is identical to b"); // true
    }
    if (a==c) {
        NSLog(@"a is identical to c");
    }
    if ([a isEqual:b]) {
        NSLog(@"a is equal to b"); // true
    }
    if ([a isEqual:c]) {
        NSLog(@"a is equal to c");
    }
    
    // Object typing    
    // compiler warning! crash at runtime!
    //[a castBallot]; 
    // no compiler warning. We're casting. Compiler thinks we know what we're doing
    //Person * aPerson = (Person *) a; 
    // we've forced the ccompiler to think NSString is a Person. crash at runtime
    //[aPerson castBallot]; 
    // no compiler warning. We've forced the compiler to ignore the object type by "casting". crash at runtime
    //[(id)a castBallot]; 
    
    // when we're done with person, release it!
    [person release];       // person will be destroyed here
    person = nil;
    [person castBallot];    // no effect!
    [person2 release];       // person2 will be destroyed here
    person2 = nil;
}

@end
